package dev.shadowsoffire.apotheosis.ench.compat;

import net.minecraft.core.BlockPos;
import it.unimi.dsi.fastutil.objects.ObjectIterator;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.Blocks;
import java.util.function.Consumer;
import dev.shadowsoffire.apotheosis.util.CommonTooltipUtil;
import java.util.Objects;
import net.minecraft.world.item.enchantment.Enchantment;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import mcjty.theoneprobe.api.IProbeHitData;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import dev.shadowsoffire.placebo.compat.TOPCompat;

public class EnchTOPPlugin implements TOPCompat.Provider
{
    public static void register() {
        TOPCompat.registerProvider((TOPCompat.Provider)new EnchTOPPlugin());
    }
    
    public void addProbeInfo(final ProbeMode mode, final IProbeInfo info, final Player player, final Level level, final BlockState state, final IProbeHitData hitData) {
        final BlockEntity 7702_ = level.m_7702_(hitData.getPos());
        if (7702_ instanceof final AnvilTile anvil) {
            final Object2IntMap<Enchantment> enchants = (Object2IntMap<Enchantment>)anvil.getEnchantments();
            for (final Object2IntMap.Entry<Enchantment> e : enchants.object2IntEntrySet()) {
                info.text(((Enchantment)e.getKey()).m_44700_(e.getIntValue()));
            }
        }
        final BlockPos pos = hitData.getPos();
        Objects.requireNonNull(info);
        CommonTooltipUtil.appendBlockStats(level, state, pos, (Consumer)info::mcText);
        if (state.m_60734_() == Blocks.f_50201_) {
            final BlockPos pos2 = hitData.getPos();
            Objects.requireNonNull(info);
            CommonTooltipUtil.appendTableStats(level, pos2, (Consumer)info::mcText);
        }
    }
}
